module.exports = require('yargs')
	.usage('\nUsage:\n  node $0 [options] -e="./someProcess"')
	.alias('e', 'exec')
	.default('port', 8080)
	.alias('p', 'password')
	.alias('ssl', 'https')
	.boolean('ssl')
	.alias('ssl-key', 'key')
	.alias('ssl-cert', 'cert')
	.alias('ssl-passphrase', 'passphrase')
	.describe('ssl', 'Add https support')
	.describe('ssl-key', 'Route to SSL key (required if ssl flag)')
	.describe('ssl-cert', 'Route to SSL certificate (required if ssl flag)')
	.describe('ssl-passphrase', 'Specifies SSL private passphrase')
	.describe('port', 'Set the port to listen')
	.describe('e', 'Set the command you want to execute')
	.describe('p', 'Set a specific password to the WebSocket server')
	.demand(['e'])
	.implies('ssl', 'ssl-cert')
	.implies('ssl-cert', 'ssl-key')
	.implies('ssl-key', 'ssl-passphrase')
	.env('NWS')
	.argv;